<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is
 * licensed under The BSD license.

 * ---
 * Copyright (c) 2009, Skalfa LLC
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:
 *
 *  - Redistributions of source code must retain the above copyright notice, this list of conditions and
 *  the following disclaimer.
 *
 *  - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *  the following disclaimer in the documentation and/or other materials provided with the distribution.
 *
 *  - Neither the name of the Skalfa LLC nor the names of its contributors may be used to endorse or promote products
 *  derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/**
 * Data Transfer Object for `activity_action` table
 *
 * @author Aybat Duyshokov <duyshokov@gmail.com>
 * @package ow_plugins.activity.bol
 * @since 1.0
 */
class ACTIVITY_BOL_Action extends OW_Entity
{
    public $userId, $entityId, $type, $status = 'active', $timestamp, $data;

    /**
     *
     * @return ACTIVITY_BOL_Action
     */
    public function setUserId( $userId )
    {
        $this->userId = $userId;

        return $this;
    }

    public function getUserId()
    {
        return $this->userId;
    }

    /**
     *
     * @return ACTIVITY_BOL_Action
     */
    public function setEntityId( $entityId )
    {
        $this->entityId = $entityId;

        return $this;
    }

    public function getEntityId()
    {
        return $this->entityId;
    }

    /**
     *
     * @return ACTIVITY_BOL_Action
     */
    public function setType( $type )
    {
        $this->type = $type;

        return $this;
    }

    public function getType()
    {
        return $this->type;
    }

    /**
     *
     * @return ACTIVITY_BOL_Action
     */
    public function setStatus( $status )
    {
        $this->status = $status;

        return $this;
    }

    public function getStatus()
    {
        return $this->status;
    }

    /**
     *
     * @return ACTIVITY_BOL_Action
     */
    public function setTimestamp( $timestamp )
    {
        $this->timestamp = $timestamp;

        return $this;
    }

    public function getTimestamp()
    {
        return $this->timestamp;
    }

    /**
     * 
     * @return ACTIVITY_BOL_Action
     */
    public function setData( $data )
    {
        $this->data = self::getDataJson($data);

        return $this;
    }

    public function getData()
    {
        $o = json_decode($this->data);
        $len = 200;

        $o->content_comment = mb_ereg_replace('\<.*?\>', '', (empty($o->content_comment) ? '' : $o->content_comment));

        if ( mb_strlen($o->content_comment) > $len )
        {
            $o->content_comment = mb_substr($o->content_comment, 0, $len) . '...';
        }

        return $o;
    }

    private static function getDataJson( $data )
    {
        if ( !count($data) )
        {
            return '{}';
        }

        //ksort($data, SORT_STRING);

        return json_encode($data);
    }
}