<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is
 * licensed under The BSD license.

 * ---
 * Copyright (c) 2009, Skalfa LLC
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:
 *
 *  - Redistributions of source code must retain the above copyright notice, this list of conditions and
 *  the following disclaimer.
 *
 *  - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *  the following disclaimer in the documentation and/or other materials provided with the distribution.
 *
 *  - Neither the name of the Skalfa LLC nor the names of its contributors may be used to endorse or promote products
 *  derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/**
 * @author Aybat Duyshokov <duyshokov@gmail.com>
 * @package ow_plugins.contact_importer.controllers
 * @since 1.0
 */
class CONTACTIMPORTER_CTRL_Fstep2 extends OW_ActionController
{

    public function __construct()
    {
        parent::__construct();
    }

    public function index()
    {
        OW::getDocument()->getMasterPage()->setTemplate(OW::getThemeManager()->getMasterPageTemplate(OW_MasterPage::TEMPLATE_BLANK));

        $l = OW::getLanguage();

        $params = OW::getRequest()->getInstance()->getUriParams();

        $apikey = OW::getConfig()->getValue('contact_importer', 'facebook_api_key');

        $action = OW::getRouter()->urlFor('CONTACTIMPORTER_CTRL_Fstep3', 'index');


        $type = OW::getConfig()->getValue('base', 'site_name');

        $userId = OW::getUser()->getId();
        $code = UTIL_String::generatePassword(10);

        BOL_UserService::getInstance()->saveUserInvitation($userId, $code);
        $joinUrl = OW::getRequest()->buildUrlQueryString(OW::getRouter()->urlForRoute('base_join'), array('code' => $code));

        $content = $l->text('contact_importer', 'facebook_inv_text', array('fb_id' => $params['id'], 'joinUrl' => $joinUrl));

        $actionText = $l->text('contact_importer', 'facebook_inv_action');

        exit('
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:fb="http://www.facebook.com/2008/fbml"> 
	<head></head>
	<body>
 <script src="http://static.ak.connect.facebook.com/connect.php/en_GB" type="text/javascript"></script>
 <script type="text/javascript">FB.init("' . $apikey . '");</script>

<fb:serverfbml style="width: 776px;"> 
	<script type="text/fbml"> 
		<fb:fbml> 
			<fb:request-form
			action="' . $action . '"
			method="POST" invite="true" type="' . $type . '"
			content="' . $content . '" >
				<fb:multi-friend-selector showborder="false" actiontext="' . $actionText . '" />
			</fb:request-form>
		</fb:fbml>
	</script>
</fb:serverfbml>

	</body>
</html>
');
    }
}
?>
