<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is
 * licensed under The BSD license.

 * ---
 * Copyright (c) 2009, Skalfa LLC
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:
 *
 *  - Redistributions of source code must retain the above copyright notice, this list of conditions and
 *  the following disclaimer.
 *
 *  - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *  the following disclaimer in the documentation and/or other materials provided with the distribution.
 *
 *  - Neither the name of the Skalfa LLC nor the names of its contributors may be used to endorse or promote products
 *  derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/**
 * @author Aybat Duyshokov <duyshokov@gmail.com>
 * @package ow_plugins.contact_importer.controllers
 * @since 1.0
 */
class CONTACTIMPORTER_CTRL_Gstep1 extends OW_ActionController
{

    public function __construct()
    {
        parent::__construct();
    }

    public function index()
    {
        if ( !empty($_SESSION['gc']) )
        {
            $_SESSION['gc'] = null;
        }

        OW::getDocument()->getMasterPage()->setTemplate(OW::getThemeManager()->getMasterPageTemplate(OW_MasterPage::TEMPLATE_BLANK));


        $jsPath = OW::getPluginManager()->getPlugin('contactimporter')->getStaticJsUrl();

        OW::getDocument()->addScript('http://www.google.com/jsapi');
        OW::getDocument()->addScript("http://www.google.com/jsapi?autoload=%7Bmodules%3A%5B%7Bname%3Agdata%2Cversion%3A2.x%2Cpackages%3A%5Bblogger%2Ccontacts%5D%7D%5D%7D");
        OW::getDocument()->addScript($jsPath . 'gmail.js');
        $u = OW::getRouter()->urlFor('CONTACTIMPORTER_CTRL_Gstep1');
        OW::getDocument()->addScriptDeclaration("
		 
		initFunc = function()
		{
			setupContactsService();
			if( !isLoggedIn() ){
			
				if( location.href == '$u' )
				{
					il = '0';
				}
				else 
					il = '5000';

				setTimeout(function(){
					logMeIn();
				}, il);
			}
			else {
				document.location.href = '" . OW::getRouter()->urlFor('CONTACTIMPORTER_CTRL_Gstep2') . "';
			}
		}

		google.setOnLoadCallback(initFunc);		

		");

        $src = OW::getPluginManager()->getPlugin('contactimporter')->getStaticUrl() . 'img/ajax-loader.gif';
        $this->assign('img', "<img src=\"{$src}\" />");
    }
}