<?php

/**
 * Copyright (c) 2009, Skalfa LLC
 * All rights reserved.

 * ATTENTION: This commercial software is intended for use with Oxwall Free Community Software http://www.oxwall.org/
 * and is licensed under Oxwall Store Commercial License.
 * Full text of this license can be found at http://www.oxwall.org/store/oscl
 */

/**
 * Invitation Sending Controller
 *
 * @author Aybat Duyshokov <duyshokov@gmail.com>
 * @package ow_plugins.contact_importer.controllers
 * @since 1.0
 */
class CONTACTIMPORTER_CTRL_Invite extends OW_ActionController
{

    public function index()
    {
        $user = OW::getUser()->getUserObject();
        $displayname = BOL_UserService::getInstance()->getDisplayName($user->getId());

        if ( !empty($_POST['command']) && $_POST['command'] = 'send-invitations' )
        {

            foreach ( $_POST['email'] as $email )
            {
                $msg = !empty($_POST['custom_text']) && trim($_POST['custom_text']) != OW::getLanguage()->text('contact_importer', 'page_invite_custom_message') ? $_POST['custom_text'] : null;
                $this->invite($user, $displayname, $email, $msg);
            }

            OW::getFeedback()->info(OW::getLanguage()->text('contact_importer', 'feedback_invitation_sent'));

            $this->redirect(OW::getRouter()->urlForRoute('base_member_dashboard'));
        }

        $list = $this->getEmails();

        $this->assign('list', $list);
    }

    private function invite( $user, $displayname, $email, $text=null )
    {
        $language = OW::getLanguage();

        $userUrl = BOL_UserService::getInstance()->getUserUrl($user->getId());
        $userLink = "<a href=\"{$userUrl}\">{$userUrl}</a>";

        $code = UTIL_String::generatePassword(10);

        BOL_UserService::getInstance()->saveUserInvitation(OW::getUser()->getId(), $code);

        $joinUrl = OW::getRequest()->buildUrlQueryString(OW::getRouter()->urlForRoute('base_join'), array('code' => $code));

        $vars = array(
            'userlink' => $userLink,
            'displayname' => $displayname,
            'useremail' => $user->getEmail(),
            'joinlink' => $joinUrl
        );

        $subject = $language->text('contact_importer', 'invite_subject', $vars);

        if ( $text )
        {
            $template_html = nl2br($text) . '<br /> <a href="' . OW::getRouter()->urlForRoute('base_join') . '">' . OW::getRouter()->urlForRoute('base_join') . '</a>';
            $template_text = $text . "\n" . OW::getRouter()->urlForRoute('base_join');
        }
        else
        {
            $template_html = $language->text('contact_importer', 'invite_template_html', $vars);
            $template_text = $language->text('contact_importer', 'invite_template_text', $vars);
        }

        $mail = OW::getMailer()->createMail();
        $mail->addRecipientEmail($email);
        $mail->setSubject($subject);
        $mail->setSender($user->getEmail(), $displayname);
        $mail->setHtmlContent($template_html);
        $mail->setTextContent($template_text);

        OW::getMailer()->send($mail);
    }

    private function filter( $emails )
    {
        $userService = BOL_UserService::getInstance();

        $users = (array) $userService->findListByEmailList($emails);

        $arr2 = array();

        foreach ( $users as $user )
        {
            if ( !in_array($user->getEmail(), $emails) )
            {
                continue;
            }

            $arr2[] = $user->getEmail();
        }

        return array_diff($emails, $arr2);
    }

    private function getEmails()
    {
        if ( empty($_SESSION['gc']) )
        {
            return array();
        }

        $list = $_SESSION['gc'];

        return $this->filter($list);
    }
}