<?php

/**
 * Copyright (c) 2009, Skalfa LLC
 * All rights reserved.

 * ATTENTION: This commercial software is intended for use with Oxwall Free Community Software http://www.oxwall.org/
 * and is licensed under Oxwall Store Commercial License.
 * Full text of this license can be found at http://www.oxwall.org/store/oscl
 */

/**
 * Yahoo Contacts Import step 1
 *
 * @author Aybat Duyshokov <duyshokov@gmail.com>
 * @package ow_plugins.contact_importer.controllers
 * @since 1.0
 */
class CONTACTIMPORTER_CTRL_Ystep1 extends OW_ActionController
{

    public function index( $params )
    {

        OW::getDocument()->getMasterPage()->setTemplate(OW::getThemeManager()->getMasterPageTemplate(OW_MasterPage::TEMPLATE_BLANK));

        require dirname(__FILE__) . '/../yahoo/Yahoo.inc';

        //								#####	api data	#####
        define('OAUTH_CONSUMER_KEY', OW::getConfig()->getValue('contact_importer', 'yahoo_consumer_key'));
        define('OAUTH_CONSUMER_SECRET', OW::getConfig()->getValue('contact_importer', 'yahoo_consumer_secret'));
        define('OAUTH_DOMAIN', str_replace('http://', '', OW_URL_HOME));

        define('OAUTH_APP_ID', OW::getConfig()->getValue('contact_importer', 'yahoo_app_id'));

        //								#####	~api data	#####

        $src = OW::getPluginManager()->getPlugin('contactimporter')->getStaticUrl() . 'img/ajax-loader.gif';
        $this->assign('img', "<img src=\"{$src}\" />");

        $hasSession = YahooSession::hasSession(OAUTH_CONSUMER_KEY, OAUTH_CONSUMER_SECRET, OAUTH_APP_ID);

        if ( $hasSession == FALSE )
        {
            $callback = YahooUtil::current_url() . "?in_popup";
            $auth_url = YahooSession::createAuthorizationUrl(OAUTH_CONSUMER_KEY, OAUTH_CONSUMER_SECRET, $callback);
            OW::getDocument()->addOnloadScript("window.location.href='{$auth_url}';");
        }
        else
        {
            $session = YahooSession::requireSession(OAUTH_CONSUMER_KEY, OAUTH_CONSUMER_SECRET, OAUTH_APP_ID);

            $user = $session->getSessionedUser();

            $arr = $user->getContacts(0, 200);

            $_SESSION['gc'] = array();

            foreach ( $arr->contacts->contact as $contact )
            {
                $_SESSION['gc'][] = $contact->fields[0]->value;
            }

            YahooSession::clearSession();

            OW::getDocument()->addOnloadScript('window.opener.location.href="' . OW::getRouter()->urlForRoute('contact-importer-add') . '"; window.close()');
        }
    }
}