<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is
 * licensed under The BSD license.

 * ---
 * Copyright (c) 2009, Skalfa LLC
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:
 *
 *  - Redistributions of source code must retain the above copyright notice, this list of conditions and
 *  the following disclaimer.
 *
 *  - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *  the following disclaimer in the documentation and/or other materials provided with the distribution.
 *
 *  - Neither the name of the Skalfa LLC nor the names of its contributors may be used to endorse or promote products
 *  derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/**
 * @author Aybat Duyshokov <duyshokov@gmail.com>
 * @package ow_plugins.contact_importer
 * @since 1.0
 */
OW::getRouter()->addRoute(new OW_Route('contact-importer-add', 'contact-importer/add', 'CONTACTIMPORTER_CTRL_Add', 'index'));
OW::getRouter()->addRoute(new OW_Route('contact-importer-invite', 'contact-importer/invite', 'CONTACTIMPORTER_CTRL_Invite', 'index'));
OW::getRouter()->addRoute(new OW_Route('contact-importer-admin', 'admin/contact-importer', "CONTACTIMPORTER_CTRL_Admin", 'index'));

OW::getRouter()->addRoute(new OW_Route('contact-importer_xd', 'xd_receiver.htm', 'CONTACTIMPORTER_CTRL_Xd', 'index'));

$ydvFile = OW::getConfig()->getValue('contact_importer', 'yahoo_domain_verification_file');
if ( !empty($ydvFile) )
{
    OW::getRouter()->addRoute(new OW_Route('contact-importer_yahoo-domain-verify', $ydvFile, 'CONTACTIMPORTER_CTRL_Ydv', 'index'));
}

function contactimporter_on_user_register( OW_Event $event )
{
    $params = $event->getParams();

    if ( !OW::getPluginManager()->isPluginActive('friends') || empty($params['params']['code']) )
    {
        return;
    }

    $service = BOL_UserService::getInstance();

    $code = $params['params']['code'];

    $newId = $params['userId'];

    $invite = $service->findInvitationInfo($code);
    $userId = (int) $invite->getUserId();

    if ( $userId === 0 )
    {
        return;
    }

    $fService = FRIENDS_BOL_Service::getInstance();

    $fService->request($userId, $newId);
    $fService->accept($newId, $userId);
}
OW::getEventManager()->bind(OW_EventManager::ON_USER_REGISTER, 'contactimporter_on_user_register');

/*
  UPDATE `ow2`.`ow_base_plugin` SET `adminSettingsRoute` = 'contact-importer-admin' WHERE `ow_base_plugin`.`id` =13 LIMIT 1 ;
  //OW::getConfig()->addConfig('contact_importer', 'yahoo_domain_verification_file', '', '');
 */