<?php

/**
 * Smarty function
 *
 * @param mixed params
 * @package OW_Smarty $smarty
 */

function smarty_function_user_avatar( $params, $smarty )
{
    $avatarService = BOL_AvatarService::getInstance();
    $output=''; $url = '';

    $class = isset($params['class']) ? ' class="' . trim($params['class']) . '"' : '';

    if ( isset($params['url']) )
    {
        $url = trim($params['url']);
    }
    
    if ( isset($params['src']) )
    {
        $src = trim($params['src']);
    }
    else if ( isset($params['userId']) )
    {
        $src = $avatarService->getAvatarUrl((int)$params['userId']);          
    }
    else
    {
        $src = $avatarService->getDefaultAvatarUrl();
    }
    
    if ( strlen($url) )
    {
        $output = '<a href="'.$url.'"><img ' . $class . ' alt="" src="' . $src . '" /></a>';
    }
    else 
    {
        $output = '<img ' . $class . ' alt="" src="' . $src . '" />';
    }

    return $output;
}