<?php
class BASE_CMP_LanguageValueEdit extends OW_Component
{
	public function __construct($prefix, $key)
	{
		parent::__construct('language_value_edit');

		$this->addForm(new LanguageValueEditForm($prefix, $key, $this));
	}

	public static function process($prefix, $key)
	{

		$languageService = BOL_LanguageService::getInstance();
		$list = $languageService->findActiveList();
                $currentLanguageId = OW::getLanguage()->getCurrentId();
                $currentLangValue = "";

		foreach($list as $item)
		{
			$keyDto = $languageService->findKey($prefix, $key);

			$value = $_POST['lang'][$item->getId()][$prefix][$key];

			$dto = $languageService->findValue($item->getId(), $keyDto->getId() );

			if( $dto !== null )
			{
				if($dto->getValue() !== $value)
				{
					$languageService->saveValue( $dto->setValue( $value ) );
				}
			}
			else
			{
				$dto = $languageService->addValue( $item->getId(), $prefix, $key, $value );
			}

                        if( (int)$currentLanguageId === (int)$item->getId() )
                        {
                            $currentLangValue = $value;
                        }
		}

		exit("{'result':'success', 'prefix':'{$prefix}', 'key':'{$key}', 'value':'{$currentLangValue}'}");
	}
}

class LanguageValueEditForm extends Form
{
	public function __construct($prefix, $key, &$parent)
	{
		parent::__construct('lang-values-edit');

		$this->setAjax(true);
		$this->setAction( OW::getRouter()->urlFor('ADMIN_CTRL_Languages', 'ajaxEditLangs')."?prefix={$prefix}&key={$key}" );

		$languageService = BOL_LanguageService::getInstance();
		$list = $languageService->findActiveList();

		$parent->assign('langs', $list);
		$parent->assign('prefix', $prefix);
		$parent->assign('key', $key);

		foreach($list as $item)
		{
			$textArea = new Textarea("lang[{$item->getId()}][{$prefix}][{$key}]");
			$dto = $languageService->getValue($item->getId(), $prefix, $key);

			$value = ($dto !== null)? $dto->getValue(): '';

			$textArea->setValue( $value );

			$this->addElement($textArea);
		}

		$submit = new Submit( 'submit' );

		$submit->setValue( 'Save' );

		OW::getDocument()->addOnloadScript(
		"owForms['{$this->getName()}'].bind('success', function(json){
			switch( json['result'] ){
				case 'success':
					var fb = document['ajaxLangValueEditForms'][ json['prefix'] +'-'+ json['key'] ];
                                        var ff = document['ajaxLangValueEditForms'][json['prefix'] +'-'+json['key']+'callback'];
                                        ff(json);
					fb.close();

					break;
			}
		})");

		$this->addElement($submit);
	}
}